"use strict";
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@angular/core");
var http_1 = require("@angular/common/http");
var Observable_1 = require("rxjs/Observable");
require("rxjs/add/observable/throw");
require("rxjs/add/operator/map");
require("rxjs/add/operator/catch");
var ngx_restangular_helper_1 = require("./ngx-restangular-helper");
var RestangularHttp = /** @class */ (function () {
    function RestangularHttp(http) {
        this.http = http;
    }
    RestangularHttp.prototype.createRequest = function (options) {
        var request = ngx_restangular_helper_1.RestangularHelper.createRequest(options);
        return this.request(request);
    };
    RestangularHttp.prototype.request = function (request) {
        var _this = this;
        return this.http.request(request.method, request.url, __assign({}, request, { observe: 'response' }))
            .map(function (response) {
            if (!response.ok) {
                return Observable_1.Observable.throw(new http_1.HttpErrorResponse(response));
            }
            return response;
        })
            .map(function (response) {
            response.config = { params: request };
            return response;
        })
            .catch(function (err) {
            err.request = request;
            err.data = err.error;
            err.repeatRequest = function (newRequest) {
                return _this.request(newRequest || request);
            };
            return Observable_1.Observable.throw(err);
        });
    };
    RestangularHttp.decorators = [
        { type: core_1.Injectable },
    ];
    /** @nocollapse */
    RestangularHttp.ctorParameters = function () { return [
        { type: http_1.HttpClient, },
    ]; };
    return RestangularHttp;
}());
exports.RestangularHttp = RestangularHttp;
//# sourceMappingURL=ngx-restangular-http.js.map